package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.YCSQ;
import com.sa.ibiz.demo.demo.service.YCSQService;
import com.sa.ibiz.demo.demo.service.dto.YCSQSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/ycsq")
public class YCSQResource
{
	@Autowired
	private YCSQService service;


	@PostMapping(value = "/update")
	public ResponseEntity<YCSQ> update(@Validated @RequestBody YCSQ data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("用车申请[update]操作发生错误","YCSQ",data.getYcsqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<YCSQ> create(@Validated @RequestBody YCSQ data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("用车申请[create]操作发生错误","YCSQ",data.getYcsqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<YCSQ> get(@Validated @PathVariable String id){
		YCSQ data=new YCSQ();
		data.setYcsqid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("用车申请[get]操作发生错误","YCSQ",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<YCSQ> getDraft(@Validated @RequestBody YCSQ data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("用车申请[getDraft]操作发生错误","YCSQ","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<YCSQ> checkKey(@Validated @RequestBody YCSQ data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("用车申请[checkKey]操作发生错误","YCSQ",data.getYcsqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<YCSQ> remove(@Validated @RequestBody YCSQ data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("用车申请[remove]操作发生错误","YCSQ",data.getYcsqid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<YCSQ>> searchDefaultPage(@Validated @RequestBody YCSQSearchFilter filter){
		Page<YCSQ> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<YCSQ>> listDefault(@Validated @RequestBody YCSQSearchFilter filter){
		List<YCSQ> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
